package org.openxma.addons.ui.table.customizer.xma.client;

import java.util.Calendar;
import java.util.Date;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.openxma.addons.ui.table.customizer.common.CommonDataModel.FilterOperator;

import at.spardat.xma.page.PageClient;

/**
 */
public class FilterEmTimestamp extends FilterEmTimestampGen {

    /**
     * Constructs the FilterEmTimestampGen.
     * @param parent the page where this page is embedded.
     */
    public FilterEmTimestamp(PageClient parent) {
        super(parent);
    }

    /**
     * This method will be called every time the FilterEmTimestamp becomes visible.
     */
    protected void enter() {
        super.enter();
        //TODO implement enter here!
    }
    
    @Override
    protected void createWidgets() {
        super.createWidgets();
        ((FilterPage)getParent()).applyUIPref(getComposite());
        valueFilter.setFmt(((FilterPage)getParent()).getCurrentFmt());
        valueFilter.set(createDefaultDate());
        
    }

    private Date createDefaultDate() {
        /*Calendar cal = Calendar.getInstance();
        cal.set(Calendar.HOUR_OF_DAY, 0);
        cal.set(Calendar.MINUTE, 0);
        cal.set(Calendar.SECOND, 0);
        cal.set(Calendar.MILLISECOND, 0);
        return cal.getTime();*/
        return new Date(0);
    }
    
    /**
     * Enables or disables Widgets according to the current state of the page.
     * This method is called every time the content of any WizardModel of the
     * Page may have been changed. <br>
     * This method is called immediately after {@link #determineState()}.
     */
    public void stateChanged() {
        super.stateChanged();
        
        if (FilterOperator.isnull.getStringValue().equals(operatorCombo.getSelected())
                || FilterOperator.notnull.getStringValue().equals(operatorCombo.getSelected())) {
            valueFilter.setMandatory(false);
            valueFilterW.setVisible(false);
        } else {
            valueFilter.setMandatory(true);
            valueFilterW.setVisible(true);
        }
        boolean valid = !hasValidationError(valueFilterW) && operatorCombo.getSelected()!=null;
        
        addButtonW.setEnabled(valid);

        int indexOf = ((FilterPage)getParent()).elements.indexOf(this);
        if (indexOf > 0) { // not the first element
            valueFilter.setEnabled(linkOperandCombo.getSelected()!=null && operatorCombo.getSelected()!=null);
        }
        
        ((FilterPage)getParent()).updateApplyFilterButton();
    }
    
    @Override
    protected void removeButtonWEvent() {
        ((FilterPage)getParent()).removeFilter(this);
    }

    @Override
    protected void addButtonWEvent() {
        ((FilterPage)getParent()).addFilter();
    }
    
    @Override
    protected void clientEvent(SelectionEvent event, int type) {
        super.clientEvent(event, type);
        if (event.widget == linkOperandComboW && SWT.Selection == type) {
            if (linkOperandCombo.getSelected()!=null) {
                ((FilterPage)getParent()).adjustFilterLinkOperators(linkOperandCombo.getSelected(), this);
            }
        }
    }
}
